package CTL.Comm;

import CTL.Types.*;

import java.io.*;
import java.net.*;

/** Interface for all CTL communicators */
public interface Communicator
{	
	PeerID pid ();

	void send (byte[] data, int len) throws IOException;
	void send (byte[] data) throws IOException;

	byte[] recv () throws IOException, CTLException;
	byte[] recv (int len) throws IOException, CTLException;

	void accept () throws IOException;
	void connect (PeerID remote) throws UnknownHostException, IOException;
	void close () throws IOException;
	void listen () throws IOException;
}
