package CTL;

import CTL.Types.*;

import java.io.*;
import java.lang.reflect.*;

/** Simple debugging output handler */
public class Debugger
{
	/** Print out debugging output for a certain RMI invocation
	 * @param type Type of the RMI method (call or answer)
	 * @param head Header of this package
	 * @param baos Byte stream which this invocation generated
	 */
	public static void RMIdump (String type, Header head, 
		ByteArrayOutputStream baos) throws IOException, IllegalAccessException,
		InvocationTargetException, CTLException
	{
		RMIdump(type, head, baos.toByteArray());
	}

	/** RMI debug message printer
	 * @param type Type of communication
	 * @param head Header
	 * @param buf Payload
	 */
	public static void RMIdump (String type, Header head, byte[] buf) throws
		IOException, IllegalAccessException, InvocationTargetException,
		CTLException
	{
		Env.log.log_msg(Logger.DBG, "\nRMI "+type+" -- Header size: "+
			head.size()+" Bytes -- Payload size: "+head.getSize()+" Bytes");
		Env.log.log_msg(Logger.DBG, "\t\t.:. Dump of payload .:.");
		
		Tools.HexDumper dump = new Tools.HexDumper(buf);
		Env.log.log_msg(Logger.DBG, dump.convert()+"\n");
	}
}
