package CTL;

/** Abstract base class for all remote interfaces */
public abstract class RI
{
	/** Environment data */
	protected static Env env = null;
	/** Process information */
	private static Process proc = null;
	/** ObjectID */
	private long objID = -1;

	/** Retrieve the objID of this object
	 * @return ObjectID
	 */
	public long objID ()
	{
		return objID;
	}

	/** Set an objID for this object
	 * @param ID ObjectID
	 */
	public void setObjID (long ID)
	{
		objID=ID;
	}
	
	/** Set the communication process for this object
	 * @param prc Process
	 */
	public static void use (Process prc)
	{
		proc=prc;
	}

	/** Retrieve the communication process of this object
	 * @return Process
	 */
	protected static Process proc ()
	{
		return proc;
	}
}
