package CTL;

import CTL.Streams.*;
import CTL.Types.*;
import ReflWrap.*;

import java.io.*;
import java.lang.reflect.*;
import java.util.*;

/** Experimental fluff */
public class ShellService 
{
	private String[] serving = null;

	private boolean isRI (String name)
	{
		int len = name.length();
		if ((len>7)&&(name.substring(len-7, len).equals("RI.java")))
			return true;
		return false;
	}

	private String pfn (String fname)
	{
		StringTokenizer tok = new StringTokenizer(fname, ".");
		return tok.nextToken();
	}

	private void lookForRIs (String directory)
	{
		File dir = new File(directory);
		File[] classes = dir.listFiles();
		if (classes==null)
			return;
		int len = 0;
		for (int i=0;i<classes.length;i++)
			if(isRI(classes[i].getName()))
				len++;
						
		serving = new String[len];
		int j = 0;
		for (int i=0;i<classes.length;i++)
		{
			String name = classes[i].getName();
			if (isRI(name))
			{
				serving[j] = pfn(name);
				j++;
			}
		}
	}

	protected void startCB ()
	{
		lookForRIs("../src/CTL");
	}

	protected void acceptCB (OOStream out, OIStream in, Header ohead) throws
		IOException, IllegalAccessException, ClassNotFoundException,
		InstantiationException, InvocationTargetException
	{
		if (ohead.tag()==Remote.LST)
		{
			rPointer foo = in.serialRead(rPointer.class);
			int tag = in.readInt();
			out.writeArray(serving);
			return;
		}

		if (ohead.tag()==Remote.QRY)
		{
			String ri = in.readString();
			rPointer foo = in.serialRead(rPointer.class);
			int tag = in.readInt();
			
			String[] m = null;
			try
			{
				ClassInfo cinfo = new ClassInfo(Class.forName(ri));
				m = new String[cinfo.meth_here().length];
				for (int i=0;i<cinfo.meth_here().length;i++)
				{
					MethodInfo minfo = new MethodInfo(cinfo.meth_here()[i]);
					m[i] = minfo.toString();
				}
			}
			catch (ClassNotFoundException e)
			{
				m = new String[1];
				m[0] = "Class not found.";
			}
					
			out.writeArray(m);
			return;
		}
	}
}
