package CTL.Streams;

import java.io.*;

/** Replacement for Java's DataInputStream */
public class DataInputStream2 implements DataInput
{
	private DataInputStream stream;

	public DataInputStream2 (InputStream stream)
	{
		this.stream = new DataInputStream(stream);
	}

	public boolean readBoolean () throws IOException
	{
		return stream.readBoolean();
	}

	public byte readByte () throws IOException
	{
		return stream.readByte();
	}

	public char readChar () throws IOException
	{
		return stream.readChar();
	}

	public double readDouble () throws IOException
	{
		return stream.readDouble();
	}

	public float readFloat () throws IOException
	{
		return stream.readFloat();
	}

	public void readFully (byte[] b) throws IOException
	{
		stream.readFully(b);
	}

	public void readFully (byte[] b, int off, int len) throws IOException
	{
		stream.readFully(b, off, len);
	}

	public int readInt () throws IOException
	{
		return stream.readInt();
	}

	public String readLine () throws IOException
	{
		return stream.readLine();
	}

	public long readLong () throws IOException
	{
		return stream.readLong();
	}

	public short readShort () throws IOException
	{
		return stream.readShort();
	}

	public int readUnsignedByte () throws IOException
	{
		return stream.readUnsignedByte();
	}

	public int readUnsignedShort () throws IOException
	{
		return stream.readUnsignedShort();
	}

	public String readUTF () throws IOException
	{ 
		return stream.readUTF();
	}

	public int skipBytes (int n) throws IOException
	{
		return stream.skipBytes(n);
	}

	public int available () throws IOException
	{
		return stream.available();
	}

	public int read (byte[] b) throws IOException
	{
		return stream.read(b);
	}
}
