package CTL.Streams;

import java.io.*;

/** Replacement for Java's DataOutputStream */
public class DataOutputStream2 implements DataOutput
{
	private DataOutputStream stream;

	public DataOutputStream2 (OutputStream stream)
	{
		this.stream = new DataOutputStream(stream);
	}

	public void write (byte[] b) throws IOException
	{
		stream.write(b);
	}

	public void write (byte[] b, int off, int len) throws IOException
	{
		stream.write(b, off, len);
	}

	public void write (int b) throws IOException
	{
		stream.write(b);
	}

	public void writeBoolean (boolean v) throws IOException
	{
		stream.writeBoolean(v);
	}

	public void writeByte (int v) throws IOException
	{
		stream.writeByte(v);
	}

	public void writeBytes (String s) throws IOException
	{
		stream.writeBytes(s);
	}

	public void writeChar (int v) throws IOException
	{
		stream.writeChar(v);
	}

	public void writeChars (String s) throws IOException
	{
		stream.writeChars(s);
	}

	public void writeDouble (double v) throws IOException
	{
		stream.writeDouble(v);
	}

	public void writeFloat (float v) throws IOException
	{
		stream.writeFloat(v);
	}

	public void writeInt (int v) throws IOException
	{
		stream.writeInt(v);
	}

	public void writeLong (long v) throws IOException
	{
		stream.writeLong(v);
	}

	public void writeShort (int v) throws IOException
	{
		stream.writeShort(v);
	}

	public void writeShort (short v) throws IOException
	{
		stream.writeShort((int)v);
	}

	public void writeChar (char v) throws IOException
	{
		stream.writeChar((int)v);
	}

	public void writeByte (byte v) throws IOException
	{
		stream.writeByte((int)v);
	}

	public void writeUTF (String str) throws IOException
	{
		stream.writeUTF(str);
	}

	public void close () throws IOException
	{
		stream.close();
	}

	public void flush () throws IOException
	{
		stream.flush();
	}
}
