package CTL.Types;

import CTL.*;
import CTL.Serialize.*;
import CTL.Streams.*;

import java.io.*;

/** Serialization of an exception */
public class Except extends Measure implements Writable
{
	/** Name of the exception */
	private String name;

	/** Generate a nameless exception */
	public Except ()
	{
		this("");
	}

	/** Generate an exception with a certain name 
	 * @param name Name
	 */
	public Except (String name)
	{
		this.name = name;
	}

	/** Get a string representation of this object
	 * @return String
	 */
	public String toString ()
	{
		return name;
	}

	/** Get the name of this exception
	 * @return Name
	 */
	public String name ()
	{
		return name;
	}

	/** Read an exception from a stream
	 * @param in Input stream
	 */
	public void read (SerialIn in) throws IOException, 
		ClassNotFoundException
	{
		name = in.readString();
	}

	/** Write an exception to a stream
	 * @param out Output stream
	 */
	public void write (SerialOut out) throws IOException
	{
		out.writeString(name);
	}
}
