package CTL.Types;

import CTL.*;
import CTL.Serialize.*;
import CTL.Streams.*;
import ReflWrap.*;

import java.io.*;
import java.lang.reflect.*;

/** Element of CTL graph */
public class Node extends Tupel
{	
	/** Type parameters of the underlying Tupel */
	private static TypeTree[] types;

	static
	{
		types = new TypeTree[2];
		try
		{
			types[0] = new TypeTree(String.class);
			types[1] = new TypeTree(Integer.class);
		} catch (ClassNotFoundException e) {} // Never reached.
	}

	public void setTypes (TypeTree[] t)
	{
		// After 5h of debugging, this line was born, heh.
		type = types;
	}

	/** Generate a new Node
	 * @param name Name 
	 * @param cost Cost to reach this node
	 */
	public Node (String name, int cost) throws CTLException, 
		ClassNotFoundException
	{
		super(types);
		setItem(0, name);
		setItem(1, cost);
	}

	/** Retrieve the name of this Node
	 * @return String
	 */
	public String name ()
	{
		try
		{
			return (String)item(0);
		}
		catch (CTLException e)
		{
			return null;
		}
	}

	/** Retrieve the cost of this Node
	 * @return Cost
	 */
	public int cost ()
	{
		try
		{
			return (Integer)item(1);
		}
		catch (CTLException e)
		{
			return -1;
		}
	}

	/** Retrieve a String representation of this object
	 * @return String
	 */
	public String toString ()
	{
		return name();
	}

	/** Serial read function
	 * @param in Input stream
	 */
	public void read (OIStream in) throws IOException, ClassNotFoundException, 
		InstantiationException, IllegalAccessException, InvocationTargetException
	{
		//System.out.println("moongoo");
		try
		{
			setItem(0, in.readString());
			setItem(1, in.readInt());
			//System.out.println(item(0)+" "+item(1));
		} 
		catch (CTLException e) 
		{
			RUtil.except(e);
		}
	}
}
