package Components;

import de.tubs.cs.iti.krypto.chiffre.*;
import java.io.File;
import java.io.IOException;

/** Cryptographic component */
public class Crypt
{
	/** Cipher to use */
	private Cipher c = null;
	
	/** Default constructor */
	public Crypt (String cName) throws ClassNotFoundException,
		InstantiationException, IllegalAccessException
	{
		c = (Cipher)Class.forName(cName).newInstance();
	}

	/** Generates a new key (interactive command)
	 * @param file Key file
	 */
	public void createKey (String file) throws IOException
	{
		File f0 = new File(file);
		c.makeKey();
		c.writeKey(f0);
	}

	/** Encrypt a file
	 * @param cleartxt Cleartext file
	 * @param ciphertxt Ciphertext file
	 * @param key Key file
	 */
	public void encrypt (String cleartxt, String ciphertxt, String key)
		throws IOException
	{
		File f0 = new File(cleartxt);
		File f1 = new File(ciphertxt);
		File f2 = new File(key);
		c.readKey(f2);
		c.encipher(f0, f1);
	}

	/** Decrypt a file
	 * @param cleartxt Cleartext file
	 * @param ciphertxt Ciphertext file
	 * @param key Key file
	 */
	public void decrypt (String cleartxt, String ciphertxt, String key)
		throws IOException
	{
		File f0 = new File(cleartxt);
		File f1 = new File(ciphertxt);
		File f2 = new File(key);
		c.readKey(f2);
		c.decipher(f0, f1);
	}

	/** Break the encryption of an encrypted file
	 * @param cleartxt Cleartext file
	 * @param ciphertxt Ciphertext file
	 * @param key Key file
	 * @param mod Modulus
	 */
	public void breakCipher (String cleartxt, String ciphertxt, 
		String key, int mod) throws IOException
	{
		File f0 = new File(cleartxt);
		File f1 = new File(ciphertxt);
		File f2 = new File(key);
		//c.breakCipher(f0, f1, /* tables */);
		//c.writeKey(f2);
	}
}
