package DotClass;

import ReflWrap.*;
import java.util.*;

/** List of classes */
public class ClassList
{
	/** Underlying LinkedList */
	private LinkedList<ClassListEntry> list;

	/** Generate a new ClassList */
	public ClassList ()
	{
		list = new LinkedList<ClassListEntry>();
	}

	/** Add a class to the list
	 * @param cinfo Class information
	 * @return Name of the added entry
	 */
	public String add (ClassInfo cinfo)
	{
		ClassListEntry entry = new ClassListEntry(cinfo);

		String ret = find(entry.name(), false);
		if (ret!=null)
			return ret;
		ret = find(entry.dot_name(), true);
		if (ret!=null)
			return ret;
		
		list.add(entry);
		return null;
	}

	/** Search for a certain class
	 * @param name String to search for
	 * @param isDotName Whether the string is normalized
	 * @return name if found, null otherwise
	 */
	public String find (String name, boolean isDotName)
	{
		ListIterator iter = iter();
		while (iter.hasNext())
		{
			ClassListEntry entry = (ClassListEntry)iter.next();
			if ((!isDotName)&&(entry.name().equals(name)))
				return entry.dot_name();
			if ((isDotName)&&(entry.dot_name().equals(name)))
				return entry.name();
		}
		return null;
	}

	/** Retrieve the Iterator for the underlying list
	 * @return Iterator
	 */
	public ListIterator iter ()
	{
		return list.listIterator();
	}
}
