package Hitman.HTTP;

import Hitman.HTTP.Request.Type;
import Hitman.HURL;

import java.io.IOException;

/** Simple HTTP client */
public class Client
{
	private static void client (HURL url, String[] args) throws IOException
	{
		if (!url.proto().equals("http"))
		{
			System.err.println("Unsupported protocol "+url.proto()+".");
			System.exit(1);
		}
		
		Request req = new Request(url);
		//Request req = new Request(url, Type.POST, "moongoo!", "text/plain");
		req.send(true);
		System.out.println("Moongoo!");
		byte[] content = req.getReply();
		
		if (content==null)
		{
			System.out.println("No content received.");
			System.exit(1);
		}

		System.out.println(new String(content));
	}
	
	public static void main (String[] args)
	{
		
		if (args.length<1)
		{
			System.out.println("Usage:\n\tClient $url");
			System.exit(1);
		}

		try
		{
			client(new HURL(args[0]), args);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}
