package Hitman;

import java.util.*;

/** URL parser */
public class HURL
{
	/** Username */
	private String user = null;
	/** Password */
	private String pass = null;
	/** Protocol */
	private String proto = null;
	/** Hostname */
	private String host = null;
	/** Path */
	private String path = "/index.html";
	/** Port number */
	private int port = 80;
	
	/** Parse an URL
	 * @param str String to parse 
	 */
	public HURL (String str)
	{
		StringTokenizer colon = new StringTokenizer(str, ":");
		proto = colon.nextToken();
		colon.nextToken();
		if (colon.hasMoreTokens())
		{
			StringTokenizer slash = new StringTokenizer(
				colon.nextToken(), "/");
			port = Integer.parseInt(slash.nextToken());
		}

		str = str.substring(proto.length()+3, str.length());
		StringTokenizer slash = new StringTokenizer(str, "/");
		host = slash.nextToken();
		int len = host.length();
		colon = new StringTokenizer(host, ":");
		host = colon.nextToken();
		path = str.substring(len, str.length());
	}

	/** Retrieve a string representation of this object
	 * @return String
	 */
	public String toString ()
	{	
		return proto+"://"+host+(port!=80 ? ":"+port : "")+path;
	}

	/** Retrieve the protocol
	 * @return String
	 */
	public String proto ()
	{
		return proto;
	}

	/** Retrieve the hostname
	 * @return String 
	 */
	public String host ()
	{
		return host;
	}

	/** Retrieve the port number
	 * @return Integer
	 */
	public int port ()
	{
		return port;
	}

	/** Retrieve the path
	 * @return String
	 */
	public String path ()
	{
		return path;
	}

	/** Test code */
	public static void main (String[] args)
	{
		String u0 = "http://www.icculus.org/~boris/tmp/elko.html";
		String t0 = new HURL(u0).toString();
		if (!u0.equals(t0))
			System.exit(1);

		String u1 = "http://www.google.de:8090/moo.html";
		String t1 = new HURL(u1).toString();
		if (!u1.equals(t1))
			System.exit(1);

		String u2 = "http://www.google.de:8080/moo=http://bar/";
		String t2 = new HURL(u2).toString();
		if (!u2.equals(t2))
			System.exit(1);
	}
}
