package Test;

import CTL.*;
import CTL.Types.*;
import Impl.Types.*;
import javaSys.*;

import java.util.*;
import junit.framework.*;

/** Test case for the CTL itself */
public class TClient extends TestCase
{
	private static Location loc;
	private static CTL.Process proc;

	static
	{ 
		Env.log = new Logger("/tmp/client.log", Logger.DBG);
		loc = new Location("Example.Server", 
			"/home/neocool/projects/wire/ctl4j/src", "localhost", 
			"neocool", "killgates", Location.TCP);
		proc = new CTL.Process(loc);
		
		MatheRI.use(proc); 
	}
	
	public void testMatheRI1 ()
	{
		assertTrue(MatheRI.foobar().equals("staticMethod"));
		
		MatheRI mathe_ri = new MatheRI();

		assertTrue((mathe_ri.add(4, 5)==9));
		assertTrue((mathe_ri.sub(3, 2)==1));
		assertTrue((mathe_ri.mul(2, 3)==6));
		assertTrue((mathe_ri.div(6, 2)==3));
		
		int[] foo = new int[3];
		foo[0] = foo[1] = foo[2] = 1;
		assertTrue((mathe_ri.add_a(foo)==3));
		
		assertTrue((mathe_ri.log(Math.E)==1.0));
		assertTrue((mathe_ri.log((float)Math.E)==0.99999994f));
		
		DoubleDash d = new DoubleDash(Math.E, (float)Math.E);
		DoubleDash res = mathe_ri.loglog(d);
		assertTrue(((res.getDouble()==1.0))||
					(!(res.getFloat()==0.99999994f)));
		
		assertTrue(mathe_ri.getFoo().equals(""));
		mathe_ri.setFoo("bar");
		assertTrue(mathe_ri.getFoo().equals("bar"));
	}
			
	public void testMatheRI2 ()
	{
		MatheRI mathe_ri = new MatheRI("foo");
		assertTrue(mathe_ri.getFoo().equals("foo"));
		mathe_ri = new MatheRI("bar", true);
		assertTrue(mathe_ri.getFoo().equals("bar"));
		assertTrue(MatheRI.foobar().equals("staticMethod"));
	}

	public void testEvCalcRI ()
	{
		EvCalcRI evie = new EvCalcRI();
		assertTrue((evie.barfoo(1, 1)==3));
		assertTrue((evie.barfoo(2, 3)==8));
		
		TripleDash td = new TripleDash(1.0, (float)0.0, 1.0, (float)0.0, null);
		assertTrue((evie.futzi(td)==2.0));
		
		int[] baz = new int[3];
		baz[0] = 0;
		baz[1] = 1;
		baz[2] = 2;
		td = new TripleDash(0.0, (float)0.0, 0.0, (float)0.0, baz);
		assertTrue(evie.send(td).equals(baz));
	}

	public void testrResult ()
	{
		MatheRI mathe_ri = new MatheRI("bar", true);
		
		rResult res2 = mathe_ri.add_rr(4, 5);
		assertTrue(res2!=null);
		while (!res2.received(res2.results()-1));
		assertTrue((res2.intValue(res2.results()-1)==9));
		
		res2 = MatheRI.foobar_rr();
		assertTrue(res2!=null);
		while (!res2.received(res2.results()-1));
		assertTrue(res2.StringValue(res2.results()-1).equals("staticMethod"));
	}

	public void testMOO ()
	{
		proc.stopService();
	}
}
