package Test;

import CTL.*;
import CTL.Streams.*;
import CTL.Types.*;
import Impl.Types.*;

import java.io.*;
import java.lang.reflect.*;
import junit.framework.*;

/** Another test case for the object streams
 * @see CTL.Streams.OOStream
 * @see CTL.Streams.OIStream
 */
public class TOStream extends TestCase
{
	private OOStream out;
	private OIStream in;
	
	public TOStream () throws IOException, CTLException
	{
		PipedOutputStream pout = new PipedOutputStream();
		PipedInputStream pin = new PipedInputStream(pout);
		out = new OOStream(pout);
		in = new OIStream(pin);
		
		Env.log = new Logger("test.log", Logger.DBG);
	}

	public void testCase () throws IOException, ClassNotFoundException,
		InstantiationException, IllegalAccessException, 
		InvocationTargetException, CTLException
	{		
		WriteTable foo = new WriteTable(17, "XIII");
		rPointer foo2 = new rPointer(new PeerID(new IPaddr(), 16), 17);
		out.serialWrite(foo);
		out.serialWrite(foo2);
		out.flush();
		WriteTable bar = in.serialRead(WriteTable.class);
		rPointer bar2 = in.serialRead(rPointer.class);
		assertTrue((bar.equals(foo))&&(bar2.equals(foo2)));
	}
}
