package Test;

import CTL.*;
import CTL.Streams.*;
import CTL.Types.*;
import Impl.Types.*;

import java.io.*;
import java.lang.reflect.*;
import junit.framework.*;

/** Test case for the object streams
 * @see CTL.Streams.OOStream
 * @see CTL.Streams.OIStream
 */
public class TObjectStream extends TestCase
{
	private OOStream out;
	private OIStream in;
	
	public TObjectStream () throws IOException, CTLException
	{
		PipedOutputStream pout = new PipedOutputStream();
		PipedInputStream pin = new PipedInputStream(pout);
		out = new OOStream(pout);
		in = new OIStream(pin);
		
		Env.log = new Logger("test.log", Logger.DBG);
	}

	public void testCase () throws IOException, IllegalAccessException,
		ClassNotFoundException, InstantiationException,
		InvocationTargetException, CTLException
	{
		DoubleDash test = new DoubleDash(1.0, 2.0f);
		out.writeObject(test);
		out.flush();
		DoubleDash test2 = (DoubleDash)in.readObject();
		assertTrue(test.equals(test2));
	}
}
