package Tools;

import ReflWrap.*;

/** Dumps information about available classes to the screen using the
 * java.lang.reflect package. 
 */
public class ClassDumper
{
	private final static boolean output = true;
	
	/** Dump information to the screen
	 * @param klasse Requested class
	 */
	private static void dump_class (String klasse)
	{
		try
		{
			Class foo = Class.forName(klasse);

			ClassInfo cinfo = new ClassInfo(foo);
			if (output)
				System.out.println(cinfo+" extends "+cinfo.sclass());

			for (int i=0;i<cinfo.fields().length;i++)
			{
				if (output)
					System.out.println(cinfo.fields()[i]);
			}

			for (int i=0;i<cinfo.constructors().length;i++)
			{
				ConstructInfo coinfo = new ConstructInfo
					(cinfo.constructors()[i]);
				if (output)
					System.out.println(coinfo);
			}
			
			for (int i=0;i<cinfo.methods().length;i++)
			{
				if (cinfo.methods()[i] == null)
					continue;
				MethodInfo minfo = new MethodInfo(cinfo.methods()[i]);
				if (output)
					System.out.println(minfo);
			}
		}
		catch (ClassNotFoundException e)
		{
			System.out.println("Class not found!");
		}
	}
	
	public static void main (String[] args)
	{
		if (args.length<1)
			System.out.println("No Class name given.");
		else
			dump_class(args[0]);
	}
}
